(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2007-2010                                               *)
(*    CEA   (Commissariat  l'nergie atomique et aux nergies            *)
(*           alternatives)                                                *)
(*    INRIA (Institut National de Recherche en Informatique et en         *)
(*           Automatique)                                                 *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version v2.1                *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

(* -------------------------------------------------------------------------- *)
(* --- Heuristics for Axiom instanciation                                 --- *)
(* -------------------------------------------------------------------------- *)

open Cil_types
open Clabels

(** {2 Utilities} *)

val label_name : logic_label -> string (* only for logic labels *)
val pp_labels : Format.formatter -> string list -> unit

(** {2 Collected Hints} *)

type hint = {
  h_name : string ;
  h_sigma : ( string * c_label ) list ; (* sorted by first element *)
}

val pp_hint : Format.formatter -> hint -> unit

val apply : logic_var -> (logic_label * logic_label) list -> hint list

val compute : unit -> unit
