(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2007-2010                                               *)
(*    CEA   (Commissariat  l'nergie atomique et aux nergies            *)
(*           alternatives)                                                *)
(*    INRIA (Institut National de Recherche en Informatique et en         *)
(*           Automatique)                                                 *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version v2.1                *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

open Fol

type 'd normalized = 
  | Pred of 'd d_pred 
  | Conv of 'd Fol_cc.f_let list * 'd Fol.d_pred
      
let normalize norm p = 
  match norm with
    | Wp_parameters.Let -> Pred p 
    | Wp_parameters.Exp -> Pred (Fol_eval.let_expansion p) 
    | Wp_parameters.Cc -> let defs,p = Fol_cc.unlet p in Conv (defs,p)
    | Wp_parameters.Eqs -> Pred (Fol_eqs.cc_pred p)

let coq_normalize p = 
  match Wp_parameters.get_norm () with 
    | Wp_parameters.Let -> Pred p 
    | Wp_parameters.Exp -> Pred (Fol_eval.let_expansion p) 
    | Wp_parameters.Cc -> let defs,p = Fol_cc.unlet p in Conv (defs,p)
    | Wp_parameters.Eqs -> Pred (Fol_eqs.cc_pred p)
	 
let ergo_normalize p = 
  match Wp_parameters.get_norm () with 
     | Wp_parameters.Let 
     | Wp_parameters.Exp -> Pred (Fol_eval.let_expansion p) 
     | Wp_parameters.Cc -> let defs,p = Fol_cc.unlet p in Conv (defs,p)
     | Wp_parameters.Eqs -> Pred (Fol_eqs.cc_pred p)
