(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2007-2010                                               *)
(*    CEA   (Commissariat  l'nergie atomique et aux nergies            *)
(*           alternatives)                                                *)
(*    INRIA (Institut National de Recherche en Informatique et en         *)
(*           Automatique)                                                 *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version v2.1                *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

(*
module type Iconv =
sig

  type term
  val z_to_i : Ctypes.c_int -> term -> term
  val i_to_z : Ctypes.c_int -> term -> term

end


module Create (F:Formula.S)(C:Iconv with type term = F.term) : Mfloat.S = 
struct

  let name = "machine"
  type term = F.term
 

  let () = Dictionary.open_library "float_machine.why"
 
  let f_convert = Dictionary.get_fun "f_convert"
 
  let f_conv f e = F.e_fun f_convert [F.e_int(Ctypes.f_sizeof f);e]
 (* Float cst *)
  let f_float f k = f_conv f (F.e_cst Formula.Float k)
 
 (* Float aritmetic operations *)
  let f_neg f e     = f_conv f (F.e_neg Formula.Float e)
  let f_add f e1 e2 = f_conv f (F.e_add Formula.Float e1 e2)
  let f_sub f e1 e2 = f_conv f (F.e_sub Formula.Float e1 e2)           
  let f_mul f e1 e2 = f_conv f (F.e_mul Formula.Float e1 e2)
  let f_fract f e1 e2 = f_conv f (F.e_fract e1 e2) 

  (* comparison operators on R in why *) 
    
  let f_eq f e1 e2 = f_conv f (F.e_eq Formula.Float e1 e2)  
  let f_ne f e1 e2 = f_conv f (F.e_ne Formula.Float e1 e2)
  let f_lt f e1 e2 = f_conv f (F.e_lt Formula.Float e1 e2)
  let f_le f e1 e2 = f_conv f (F.e_le Formula.Float e1 e2)  

  (* conversion on R in why *)

  let f_convert _f1 f2 e = f_conv f2 e
  let f_to_i _f i e = 
    C.z_to_i i (F.e_fun Dictionary.int_of_real [e])
  let i_to_f i f e  =
    C.i_to_z i (f_conv f (F.e_fun Dictionary.real_of_int [e]))
  let f_to_b f e = f_ne f e (F.e_float 0.0)

end  
*) 
