(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2007-2010                                               *)
(*    CEA   (Commissariat  l'nergie atomique et aux nergies            *)
(*           alternatives)                                                *)
(*    INRIA (Institut National de Recherche en Informatique et en         *)
(*           Automatique)                                                 *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version v2.1                *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

(*
module Create (F:Formula.S):Mint.S= 
struct
  let name  = "machine"
  type term = F.term
  type pred = F.pred

  let () = Dictionary.open_library "integer_machine.why"

  let i_convert_signed   = Dictionary.get_fun "i_convert_signed"
  let i_convert_unsigned = Dictionary.get_fun "i_convert_unsigned"
  let divs              = Dictionary.get_fun "divs"
  let divu              = Dictionary.get_fun "divu"
  let mods              = Dictionary.get_fun "mods"
  let modu              = Dictionary.get_fun "modu"
  let bnots    = Dictionary.get_fun "bnots"
  let bnotu    = Dictionary.get_fun "bnotu"
  let band     = Dictionary.get_fun "band"
  let bor      = Dictionary.get_fun "bor"
  let bxor     = Dictionary.get_fun "bxor"
  let lshiftu  = Dictionary.get_fun "lshiftu"
  let lshifts  = Dictionary.get_fun "lshifts"
  let rshift   = Dictionary.get_fun "rshift"

  let () = Dictionary.close_library ()

  let select_i_convert i e =
   if (Ctypes.signed i) then
        F.e_fun i_convert_signed   [F.e_int(Ctypes.sizeof i);e]
   else F.e_fun i_convert_unsigned [F.e_int(Ctypes.sizeof i);e]

 (* integer cst *)
  let i_int i k =  select_i_convert i (F.e_cst Formula.Integer k)
 
 (*arithmetic operation on int *)
    
  let i_neg i e     = select_i_convert i (F.e_neg Formula.Integer e)
  let i_add i e1 e2 = select_i_convert i (F.e_add Formula.Integer e1 e2 )
  let i_sub i e1 e2 = select_i_convert i (F.e_sub Formula.Integer e1 e2)           
  let i_mul i e1 e2 = select_i_convert i (F.e_mul Formula.Integer e1 e2)
  let i_div i e1 e2 =
    let i_convert_by = F.e_int(Ctypes.sizeof i) in 
      if (Ctypes.signed i) then 
            F.e_fun i_convert_signed   [i_convert_by;F.e_fun divs [e1;e2]]  
      else  F.e_fun i_convert_unsigned [i_convert_by;F.e_fun divu [e1;e2]]
 

  let i_mod i e1 e2 = 
    let i_convert_by = F.e_int (Ctypes.sizeof i) in 
      if (Ctypes.signed i) then 
            F.e_fun i_convert_signed   [i_convert_by;F.e_fun mods [e1;e2]]  
      else  F.e_fun i_convert_unsigned [i_convert_by;F.e_fun modu [e1;e2]]
 
    

  (* bitwise operations on int *) 

  let bits_not i e        = 
     let i_convert_by = F.e_int(Ctypes.sizeof i) in 
      if (Ctypes.signed i) then 
            F.e_fun i_convert_signed   [i_convert_by;F.e_fun bnots [e]]  
      else  F.e_fun i_convert_unsigned [i_convert_by;F.e_fun bnotu [e]]
    
  let bits_and i e1 e2    = select_i_convert i ( F.e_fun band   [e1;e2])
  let bits_or i e1 e2     = select_i_convert i ( F.e_fun bor    [e1;e2])
  let bits_xor i e1 e2    = select_i_convert i ( F.e_fun bxor   [e1;e2])
  let bits_lshift i e1 e2 = 
     let i_convert_by = F.e_int (Ctypes.sizeof i) in 
      if (Ctypes.signed i) then 
            F.e_fun i_convert_signed   [i_convert_by;F.e_fun lshifts [e1;e2]]  
      else  F.e_fun i_convert_unsigned [i_convert_by;F.e_fun lshiftu [e1;e2]]

  let bits_rshift i e1 e2 = select_i_convert i ( F.e_fun rshift [e1;e2])  
  
  (** comparaisons on int **)
      
  let i_eq _i e1 e2 =  F.e_eq Formula.Integer e1 e2  
  let i_ne _i e1 e2 =  F.e_ne Formula.Integer e1 e2
  let i_lt _i e1 e2 =  F.e_lt Formula.Integer e1 e2
  let i_le _i e1 e2 =  F.e_le Formula.Integer e1 e2  
  
  (* integers conversions *)  
 
  let i_convert _t1 t2 e = select_i_convert t2 e
  let i_to_z _te e = e
  let i_to_b _t1 e = F.e_ne Formula.Integer e (F.e_int 0)
  

end
*)
