open Cil_types

module Self =
  State_builder.False_ref
    (struct
      let name = "Test"
      let dependencies = []
      let kind = `Correctness
     end)

module Up =
  Properties_status.Make_updater
    (struct let name = "Test" let emitter = Self.self end)

module Blob =
  State_builder.False_ref
    (struct
      let name = "Blob"
      let dependencies = []
      let kind = `Correctness
     end)

let main () =
  Ast.compute ();
  Annotations.iter
    (fun s _ (ca, _) ->
      let s', kf = Kernel_function.find_from_sid s.Cil_types.sid in
      assert (Cil_datatype.Stmt.equal s s');
      let p =
	Property.IPCodeAnnot (kf, s, Annotations.get_code_annotation ca)
      in
      Up.set
	p
	[ Property.IPBlob Blob.self ]
	(Checked { emitter = "Test emitter"; valid = Maybe });
      Format.printf "%a@." Properties_status.pretty_all p)

let () = Db.Main.extend main
